From: Caleb Connolly <caleb.connolly@linaro.org>
Date: Wed, 29 Nov 2023 00:42:32 +0000
Subject: drm/panel: samsung-s6e3fc2x01: move DSI commands to .enable

Can't do these in prepare anymore

Signed-off-by: Caleb Connolly <caleb.connolly@linaro.org>
---
 drivers/gpu/drm/panel/panel-samsung-s6e3fc2x01.c | 25 ++++++++++++++++--------
 1 file changed, 17 insertions(+), 8 deletions(-)

diff --git a/drivers/gpu/drm/panel/panel-samsung-s6e3fc2x01.c b/drivers/gpu/drm/panel/panel-samsung-s6e3fc2x01.c
index 21d5408..79db007 100644
--- a/drivers/gpu/drm/panel/panel-samsung-s6e3fc2x01.c
+++ b/drivers/gpu/drm/panel/panel-samsung-s6e3fc2x01.c
@@ -171,6 +171,22 @@ static int samsung_s6e3fc2x01_disable(struct drm_panel *panel)
 	return 0;
 }
 
+static int samsung_s6e3fc2x01_enable(struct drm_panel *panel)
+{
+	struct samsung_s6e3fc2x01 *ctx = to_samsung_s6e3fc2x01(panel);
+	int ret;
+
+	ret = samsung_s6e3fc2x01_on(ctx);
+	if (ret < 0) {
+		dev_err(panel->dev, "Failed to initialize panel: %d\n", ret);
+		gpiod_set_value_cansleep(ctx->reset_gpio, 1);
+		regulator_disable(ctx->supply);
+		return ret;
+	}
+
+	return 0;
+}
+
 static int samsung_s6e3fc2x01_prepare(struct drm_panel *panel)
 {
 	struct samsung_s6e3fc2x01 *ctx = to_samsung_s6e3fc2x01(panel);
@@ -188,14 +204,6 @@ static int samsung_s6e3fc2x01_prepare(struct drm_panel *panel)
 
 	samsung_s6e3fc2x01_reset(ctx);
 
-	ret = samsung_s6e3fc2x01_on(ctx);
-	if (ret < 0) {
-		dev_err(dev, "Failed to initialize panel: %d\n", ret);
-		gpiod_set_value_cansleep(ctx->reset_gpio, 1);
-		regulator_disable(ctx->supply);
-		return ret;
-	}
-
 	ctx->prepared = true;
 	return 0;
 }
@@ -250,6 +258,7 @@ static int samsung_s6e3fc2x01_get_modes(struct drm_panel *panel,
 
 static const struct drm_panel_funcs samsung_s6e3fc2x01_panel_funcs = {
 	.prepare = samsung_s6e3fc2x01_prepare,
+	.enable = samsung_s6e3fc2x01_enable,
 	.disable = samsung_s6e3fc2x01_disable,
 	.unprepare = samsung_s6e3fc2x01_unprepare,
 	.get_modes = samsung_s6e3fc2x01_get_modes,
